import { BasicColumn, FormSchema } from '@/components/Table';

export const columns: BasicColumn[] = [
  {
    title: '名称',
    dataIndex: 'name',
    width: 120,
    // slots: { customRender: 'name' },
  },
  {
    title: '场景',
    dataIndex: 'scene',
    width: 150,
  },
  {
    title: '权属工作组',
    dataIndex: 'workgroup',
    width: 120,
  },
  {
    title: '创建时间',
    dataIndex: 'createTime',
    width: 150,
  },
  {
    title: '更新时间',
    dataIndex: 'updateTime',
    width: 150,
  },
  {
    title: '拥有者',
    dataIndex: 'owner',
    width: 100,
  },
  {
    title: '发布状态',
    dataIndex: 'releaseStatus',
    width: 120,
  },
];

export const searchFormSchema: FormSchema[] = [
  {
    field: 'name',
    label: ' ',
    component: 'Input',
    colProps: { span: 5 },
    componentProps: {
      placeholder: '输入关键字搜索',
    },
  },
  {
    field: 'releaseStatus',
    label: ' ',
    component: 'Select',
    colProps: { span: 5 },
    componentProps: {
      placeholder: '发布状态',
      options: [
        { label: '未发布', value: '未发布' },
        { label: '已发布', value: '已发布' },
        { label: '审核中', value: '审核中' },
        { label: '已下线', value: '已下线' },
      ],
    },
  },
];

export const MoveFormSchema: any[] = [
  {
    field: 'taskId',
    label: '路径',
    component: 'TreeSelect',
    colProps: { lg: 24, md: 24 },
    componentProps: {
      // border: 'none',
      fieldNames: {
        label: 'workSpaceName',
        value: 'businessId',
      },
      getPopupContainer: () => document.body,
    },
    required: true,
  },
];

export const formSchemaNewFolder: any = [
  {
    field: 'path',
    label: '路径',
    component: 'TreeSelect',
    rules: [
      {
        required: true,
        message: '请选择上级菜单',
      },
    ],
    componentProps: {
      fieldNames: {
        label: 'workSpaceName',
        value: 'businessId',
      },
      getPopupContainer: () => document.body,
    },
  },

  {
    field: 'name',
    label: '文件夹名称',
    component: 'Input',
    colProps: { span: 8 },
    componentProps: {
      placeholder: '输入文件夹名称',
    },
  },
  // {
  //   field: 'fileType',
  //   label: '权限模式',
  //   component: 'RadioGroup',
  //   defaultValue: '本级定义',
  //   colProps: { span: 8 },
  //   componentProps: {
  //     options: [
  //       { label: '本级定义', value: '本级定义' },
  //       { label: '资源自定义', value: '资源自定义' },
  //     ],
  //     placeholder: '输入描述',
  //   },
  // },
  // {
  //   field: 'group',
  //   label: '权属工作组',
  //   component: 'Select',
  //   defaultValue: '默认工作组',
  //   colProps: { span: 8 },
  //   componentProps: {
  //     placeholder: '输入描述',
  //     options: [{ label: '默认工作组', value: '默认工作组' }],
  //   },
  // },
];

export const importFormSchema: any[] = [
  {
    field: 'fileMethods',
    label: '导入文件选择',
    slot: 'fileMethods',
    colProps: { lg: 24, md: 24, offset: 3 },
  },
  {
    field: 'fileRename',
    label: '文件重名',
    component: 'RadioGroup',
    required: true,
    colProps: { lg: 24, md: 24, offset: 3 },
    componentProps: {
      options: [
        { label: '全部放弃', value: '1' },
        { label: '全部替换', value: '2' },
        { label: '自动重命名', value: '3' },
      ],
    },
  },
];

export const NewFieldRuleFormSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'newFieldRuleAlert',
    component: 'Slot',
    slot: 'newFieldRuleAlert',
  },
  {
    field: 'newFieldName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  // {
  //   field: 'newFieldType',
  //   label: '规则名称',
  //   component: 'Slot',
  //   slot: 'newFieldType',
  //   required: true,
  // },
  {
    field: 'newFieldType',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'fieldExpression',
    label: '字段表达式',
    component: 'Input',
    required: true,
  },
];

export const FieldTypeMappingRuleFormSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'newFieldRuleAlert',
    component: 'Slot',
    slot: 'newFieldRuleAlert',
  },
  {
    field: 'sourceFieldType',
    label: '源字段类型',
    component: 'Input',
    required: true,
  },
  {
    field: 'targetFieldType',
    label: '目标字段类型',
    component: 'Input',
    required: true,
  },
];

export const DataTransformationRuleFormSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'selectiveDataTable',
    label: '选择数据表',
    component: 'Select',
    componentProps: {
      options: [
        {label: 'table_1', value: 'table_1'},
        {label: 'table_2', value: 'table_2'},
        {label: 'table_3', value: 'table_3'},
        {label: 'table_4', value: 'table_4'},
      ],
    },
    required: true,
  },
  {
    field: 'conversionResultWriting',
    label: '转换结果写入',
    component: 'RadioGroup',
    defaultValue: '覆盖已有字段',
    componentProps: ({ formModel, formActionType }) => ({
      onChange: () => {
        const flag = formModel.conversionResultWriting === '覆盖已有字段';
        formActionType.updateSchema([{ field: 'selectExistingField', ifShow: flag }]);
        formActionType.updateSchema([{ field: 'newFieldName', ifShow: !flag }]);
        formActionType.updateSchema([{ field: 'newFieldType', ifShow: !flag }]);
      },
      options: [
        { label: '覆盖已有字段', value: '覆盖已有字段' },
        { label: '写入新增字段', value: '写入新增字段' },
      ],
    }),
  },
  {
    field: 'selectExistingField',
    label: '选择已有字段',
    component: 'Select',
    required: true,
    ifShow: false,
  },
  {
    field: 'newFieldName',
    label: '新增字段名称',
    component: 'Input',
    required: true,
    ifShow: false,
  },
  {
    field: 'newFieldType',
    label: '新增字段类型',
    component: 'Select',
    options: [
      { label: '覆盖已有字段', value: '覆盖已有字段' },
      { label: '写入新增字段', value: '写入新增字段' },
    ],
    required: true,
    ifShow: false,
  },
  {
    field: 'conversionRule',
    label: '转换规则',
    component: 'RadioGroup',
    defaultValue: '自定义',
    componentProps: ({ formModel, formActionType }) => ({
      onChange: () => {
        const flag = formModel.conversionRule === '自定义';
        formActionType.updateSchema([{ field: 'customRule', ifShow: flag }]);
      },
      options: [
        { label: '配置规则', value: '配置规则' },
        { label: '自定义', value: '自定义' },
      ],
    }),
  },
  {
    field: 'customRule',
    label: '自定义规则',
    component: 'InputTextArea',
    ifShow: false,
  },
];

export const FieldNameMappingRuleFormSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'regularExpressionAlert',
    component: 'Slot',
    slot: 'regularExpressionAlert',
  },
  {
    field: 'regularExpression',
    label: '正则表达式',
    component: 'Checkbox',
    componentProps: ({ formModel, formActionType }) => ({
      onChange: () => {
        const flag = formModel.regularExpression;
        formActionType.updateSchema([{ field: 'sourceDatabaseNameExpression', ifShow: flag }]);
        formActionType.updateSchema([{ field: 'targetLibraryNameExpression', ifShow: flag }]);
      },
    }),
  },
  {
    field: 'sourceDatabaseNameExpression',
    label: '源库名表达式',
    component: 'Input',
    defaultValue: '^(.*)$',
    required: true,
    ifShow: false,
  },
  {
    field: 'targetLibraryNameExpression',
    label: '目标库名表达式',
    defaultValue: 'test_$1_obs',
    component: 'Input',
    ifShow: false,
  },
  {
    field: 'addPrefix',
    label: '添加前缀',
    component: 'Checkbox',
    componentProps: ({ formModel, formActionType }) => ({
      onChange: () => {
        const flag = formModel.addPrefix;
        formActionType.updateSchema([{ field: 'prefixExpression', ifShow: flag }]);
      },
    }),
  },
  {
    field: 'prefixExpression',
    label: '表达式',
    component: 'Input',
    defaultValue: 'test_',
    required: true,
    ifShow: false,
  },
  {
    field: 'addSuffixation',
    label: '添加后缀',
    component: 'Checkbox',
    componentProps: ({ formModel, formActionType }) => ({
      onChange: () => {
        const flag = formModel.addSuffixation;
        formActionType.updateSchema([{ field: 'suffixationExpression', ifShow: flag }]);
      },
    }),
  },
  {
    field: 'suffixationExpression',
    label: '表达式',
    component: 'Input',
    defaultValue: '_obs',
    required: true,
    ifShow: false,
  },
  {
    field: 'reviewButton',
    label: '',
    component: 'Slot',
    slot: 'reviewButton',
  },
  {
    field: 'reviewTable',
    label: '',
    component: 'Slot',
    slot: 'reviewTable',
  },
];

export const SingleTableFieldMappingRuleFormSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    required: true,
  },
  {
    field: 'selectiveDataTable',
    label: '选择数据表',
    component: 'Select',
    componentProps: {
      options: [
        {label: 'table_1', value: 'table_1'},
        {label: 'table_2', value: 'table_2'},
        {label: 'table_3', value: 'table_3'},
        {label: 'table_4', value: 'table_4'},
      ],
    },
    required: true,
  },
  {
    field: 'mappingTable',
    component: 'Slot',
    slot: 'mappingTable',
  },
];
